/* ContractFile.c generated by valac 0.38.10, the Vala compiler
 * generated from ContractFile.vala, do not modify */

/*
 * Copyright (C) 2013-2017 elementary Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define CONTRACTOR_TYPE_CONTRACT_FILE (contractor_contract_file_get_type ())
#define CONTRACTOR_CONTRACT_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT_FILE, ContractorContractFile))
#define CONTRACTOR_CONTRACT_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT_FILE, ContractorContractFileClass))
#define CONTRACTOR_IS_CONTRACT_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT_FILE))
#define CONTRACTOR_IS_CONTRACT_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT_FILE))
#define CONTRACTOR_CONTRACT_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT_FILE, ContractorContractFileClass))

typedef struct _ContractorContractFile ContractorContractFile;
typedef struct _ContractorContractFileClass ContractorContractFileClass;
typedef struct _ContractorContractFilePrivate ContractorContractFilePrivate;
enum  {
	CONTRACTOR_CONTRACT_FILE_0_PROPERTY,
	CONTRACTOR_CONTRACT_FILE_NUM_PROPERTIES
};
static GParamSpec* contractor_contract_file_properties[CONTRACTOR_CONTRACT_FILE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ContractorContractFile {
	GObject parent_instance;
	ContractorContractFilePrivate * priv;
};

struct _ContractorContractFileClass {
	GObjectClass parent_class;
};

struct _ContractorContractFilePrivate {
	GFile* file;
};


static gpointer contractor_contract_file_parent_class = NULL;

GType contractor_contract_file_get_type (void) G_GNUC_CONST;
#define CONTRACTOR_CONTRACT_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CONTRACTOR_TYPE_CONTRACT_FILE, ContractorContractFilePrivate))
#define CONTRACTOR_CONTRACT_FILE_EXTENSION ".contract"
ContractorContractFile* contractor_contract_file_new (GFile* file);
ContractorContractFile* contractor_contract_file_construct (GType object_type, GFile* file);
gchar* contractor_contract_file_get_id (ContractorContractFile* self);
static gchar* contractor_contract_file_remove_extension (const gchar* file_name);
gchar* contractor_contract_file_get_contents (ContractorContractFile* self, GError** error);
gboolean contractor_contract_file_is_valid_filename (const gchar* filename);
static void contractor_contract_file_finalize (GObject * obj);


/**
     * the constructor to create ContractFile object which contains the passed
     * File object
     *
     * @param file the file to contain
     */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


ContractorContractFile* contractor_contract_file_construct (GType object_type, GFile* file) {
	ContractorContractFile * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	g_return_val_if_fail (file != NULL, NULL);
	self = (ContractorContractFile*) g_object_new (object_type, NULL);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->file);
	self->priv->file = _tmp1_;
	return self;
}


ContractorContractFile* contractor_contract_file_new (GFile* file) {
	return contractor_contract_file_construct (CONTRACTOR_TYPE_CONTRACT_FILE, file);
}


/**
     * get the contract ID from the filename, e.g. file-roller-compress
     * (file-roller-compress.contract)
     *
     * @return the contracts ID, e.g. file-roller-compress
     */
gchar* contractor_contract_file_get_id (ContractorContractFile* self) {
	gchar* result = NULL;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->file;
	_tmp1_ = g_file_get_basename (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = contractor_contract_file_remove_extension (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


/**
     * loads and returns the internally stored files content
     *
     * @return the files content as string
     */
gchar* contractor_contract_file_get_contents (ContractorContractFile* self, GError** error) {
	gchar* result = NULL;
	guint8* file_data = NULL;
	gint file_data_length1 = 0;
	gint _file_data_size_ = 0;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	guint8* _tmp2_ = NULL;
	gsize _tmp3_;
	gboolean _tmp4_;
	gchar* _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->file;
	_tmp4_ = g_file_load_contents (_tmp1_, NULL, &_tmp2_, &_tmp3_, NULL, &_inner_error_);
	file_data = (g_free (file_data), NULL);
	file_data = _tmp2_;
	file_data_length1 = _tmp3_;
	_file_data_size_ = file_data_length1;
	_tmp0_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		file_data = (g_free (file_data), NULL);
		return NULL;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ((const gchar*) file_data);
		result = _tmp5_;
		file_data = (g_free (file_data), NULL);
		return result;
	}
	_tmp6_ = g_strdup ("");
	result = _tmp6_;
	file_data = (g_free (file_data), NULL);
	return result;
}


/**
     * checks if the filename extension is '.contract'
     *
     * @param filename the full filename incl. the filename extension
     *
     * @return true if the filename extension is '.contract'; false otherwise
     */
static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_;
	glong _tmp16_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	gchar* _tmp21_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_;
		glong _tmp4_;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_;
		glong _tmp7_;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_;
		glong _tmp15_;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


gboolean contractor_contract_file_is_valid_filename (const gchar* filename) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	g_return_val_if_fail (filename != NULL, FALSE);
	_tmp0_ = filename;
	_tmp1_ = strlen (CONTRACTOR_CONTRACT_FILE_EXTENSION);
	_tmp2_ = _tmp1_;
	_tmp3_ = filename;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = string_slice (_tmp0_, (glong) (-_tmp2_), (glong) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strcmp0 (_tmp7_, CONTRACTOR_CONTRACT_FILE_EXTENSION) == 0;
	_g_free0 (_tmp7_);
	result = _tmp8_;
	return result;
}


/**
     * removes the filename extension and returns the result
     *
     * @param file_name the filename incl. the filename extesnion
     *
     * @return the filename without the filename extension
     */
static gchar* contractor_contract_file_remove_extension (const gchar* file_name) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (file_name != NULL, NULL);
	_tmp0_ = file_name;
	_tmp1_ = strlen (CONTRACTOR_CONTRACT_FILE_EXTENSION);
	_tmp2_ = _tmp1_;
	_tmp3_ = string_slice (_tmp0_, (glong) 0, (glong) (-_tmp2_));
	result = _tmp3_;
	return result;
}


static void contractor_contract_file_class_init (ContractorContractFileClass * klass) {
	contractor_contract_file_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ContractorContractFilePrivate));
	G_OBJECT_CLASS (klass)->finalize = contractor_contract_file_finalize;
}


static void contractor_contract_file_instance_init (ContractorContractFile * self) {
	self->priv = CONTRACTOR_CONTRACT_FILE_GET_PRIVATE (self);
}


static void contractor_contract_file_finalize (GObject * obj) {
	ContractorContractFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTRACTOR_TYPE_CONTRACT_FILE, ContractorContractFile);
	_g_object_unref0 (self->priv->file);
	G_OBJECT_CLASS (contractor_contract_file_parent_class)->finalize (obj);
}


/**
 * used to access the Contracts File object and read its content
 */
GType contractor_contract_file_get_type (void) {
	static volatile gsize contractor_contract_file_type_id__volatile = 0;
	if (g_once_init_enter (&contractor_contract_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContractorContractFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contractor_contract_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContractorContractFile), 0, (GInstanceInitFunc) contractor_contract_file_instance_init, NULL };
		GType contractor_contract_file_type_id;
		contractor_contract_file_type_id = g_type_register_static (G_TYPE_OBJECT, "ContractorContractFile", &g_define_type_info, 0);
		g_once_init_leave (&contractor_contract_file_type_id__volatile, contractor_contract_file_type_id);
	}
	return contractor_contract_file_type_id__volatile;
}



